package com.gic.haoban.manage.api.service.hm;

import com.gic.api.base.commons.Page;
import com.gic.haoban.base.api.common.ServiceResponse;
import com.gic.haoban.manage.api.dto.hm.HmPageQueryDTO;
import com.gic.haoban.manage.api.dto.hm.HmPageRelationQueryDTO;
import com.gic.haoban.manage.api.dto.hm.HmPageRelationRespDTO;
import com.gic.haoban.manage.api.dto.hm.HmPageTemplateDTO;
import com.gic.haoban.manage.api.dto.hm.HmPageTemplateRespDTO;

import javax.xml.ws.Service;

/**
 * @Author MUSI
 * @Date 2022/7/3 6:31 PM
 * @Description
 * @Version 落地页相关
 **/
public interface HmPageTemplateApiService {

    /**
     * 保存/修改 落地页模板
     *
     * @param pageTemplateDTO
     * @return
     */
    ServiceResponse<Long> saveOrUpdateHmPageTemplate(HmPageTemplateDTO pageTemplateDTO);

    /**
     * 删除 活码落地页
     *
     * @param pageTemplateDTO
     * @return
     */
    ServiceResponse<Boolean> deleteHmPageTemplate(HmPageTemplateDTO pageTemplateDTO);


    /**
     * 条件查询 活码落地页模板
     *
     * @param pageQueryDTO
     * @return
     */
    ServiceResponse<Page<HmPageTemplateRespDTO>> queryPageTemplateList(HmPageQueryDTO pageQueryDTO);

    /**
     * 条件查询落地页关联详情
     * @param relationQueryDTO
     * @return
     */
    ServiceResponse<Page<HmPageRelationRespDTO>> queryPageRelation(HmPageRelationQueryDTO relationQueryDTO);

}
