package com.gic.haoban.manage.service.service.hm.impl;

import com.gic.haoban.manage.api.enums.hm.HmGroupStatus;
import com.gic.haoban.manage.service.dao.mapper.hm.TabHaobanHmGroupSettingMapper;
import com.gic.haoban.manage.service.entity.hm.TabHaobanHmGroupSetting;
import com.gic.haoban.manage.service.pojo.bo.hm.HmGroupRelationBO;
import com.gic.haoban.manage.service.service.hm.HmGroupService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * @Author MUSI
 * @Date 2022/7/1 5:17 PM
 * @Description
 * @Version
 **/
@Component
public class HmGroupServiceImpl implements HmGroupService {

    private static final Logger log = LoggerFactory.getLogger(HmGroupServiceImpl.class);

    @Autowired
    private TabHaobanHmGroupSettingMapper haobanHmGroupSettingMapper;

    @Override
    public Boolean updateGroupRelationCount(Long groupId, Integer changeCount) {

        TabHaobanHmGroupSetting tabHaobanHmGroupSetting = haobanHmGroupSettingMapper.selectByPrimaryKey(groupId);
        if (tabHaobanHmGroupSetting == null || !HmGroupStatus.ENABLE.getCode().equals(tabHaobanHmGroupSetting.getStatus())){
            return Boolean.FALSE;
        }
        return haobanHmGroupSettingMapper.updateGroupSettingCount(groupId, changeCount) == 1;
    }

    @Override
    @Transactional(rollbackFor = RuntimeException.class)
    public Boolean batchUpdateGroupRelationCount(List<HmGroupRelationBO> groupRelations) {
        groupRelations.forEach(item -> {
            haobanHmGroupSettingMapper.updateGroupSettingCount(item.getGroupId(), item.getChangeCount());
        });
        return null;
    }
}
