package com.gic.haoban.manage.service.service.hm.impl;

import com.gic.api.base.commons.Page;
import com.gic.haoban.common.utils.PageUtil;
import com.gic.haoban.manage.api.enums.hm.HmPageTemplateStatus;
import com.gic.haoban.manage.service.dao.mapper.hm.TabHaobanHmPageRelationMapper;
import com.gic.haoban.manage.service.entity.hm.TabHaobanHmPageRelation;
import com.gic.haoban.manage.service.pojo.bo.hm.HmPageRelationBO;
import com.gic.haoban.manage.service.pojo.qo.HmPageRelationQO;
import com.gic.haoban.manage.service.service.hm.HmPageRelationService;
import com.github.pagehelper.PageHelper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.stream.Collectors;

/**
 * @Author MUSI
 * @Date 2022/7/3 9:45 PM
 * @Description
 * @Version
 **/
@Component
public class HmPageRelationServiceImpl implements HmPageRelationService {

    private static final Logger log = LoggerFactory.getLogger(HmPageRelationServiceImpl.class);

    @Autowired
    private TabHaobanHmPageRelationMapper haobanHmPageRelationMapper;


    @Override
    public boolean savePageRelation(HmPageRelationBO hmPageRelationBO) {
        return false;
    }

    @Override
    public boolean updateRelationStatus(HmPageRelationBO hmPageRelationBO) {
        return false;
    }

    @Override
    public List<HmPageRelationBO> queryPageTemplateRelation(String pageTemplateCode) {
        HmPageRelationQO hmPageRelationQo = new HmPageRelationQO();
        hmPageRelationQo.setTemplateCode(pageTemplateCode);
        hmPageRelationQo.setStatus(HmPageTemplateStatus.ENABLE.getCode());
        hmPageRelationQo.setPageSize(1);
        PageHelper.startPage(hmPageRelationQo.getPageNum(), hmPageRelationQo.getPageSize(), Boolean.FALSE);
        List<TabHaobanHmPageRelation> tabHaobanHmPageRelations =
                haobanHmPageRelationMapper.queryPageRelationList(hmPageRelationQo);
        return tabHaobanHmPageRelations.stream().map(item -> {
            HmPageRelationBO temp = new HmPageRelationBO();
            BeanUtils.copyProperties(item, temp);
            return temp;
        }).collect(Collectors.toList());
    }

    /**
     * 链接code/模板名称 条件查询
     *
     * @return
     */
    @Override
    public Page<HmPageRelationBO> queryPageTemplateRelationWithSearchText(HmPageRelationQO hmPageRelationQo) {
        PageHelper.startPage(hmPageRelationQo.getPageNum(), hmPageRelationQo.getPageSize());
        com.github.pagehelper.Page<TabHaobanHmPageRelation> pageRelationPage =
                (com.github.pagehelper.Page<TabHaobanHmPageRelation>) haobanHmPageRelationMapper.queryPageRelationList(hmPageRelationQo);
        return PageUtil.changePageHelperToCurrentPage(pageRelationPage, HmPageRelationBO.class);
    }
}
