package com.gic.haoban.manage.web.controller.hm;

import com.gic.haoban.base.api.common.ServiceResponse;
import com.gic.haoban.base.api.common.pojo.dto.WebLoginDTO;
import com.gic.haoban.common.utils.AuthWebRequestUtil;
import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.manage.api.dto.hm.HmGroupDTO;
import com.gic.haoban.manage.api.service.hm.HmGroupApiService;
import com.gic.haoban.manage.web.controller.WebBaseController;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;
import com.gic.haoban.manage.web.vo.hm.HmGroupSettingVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;

/**
 * @Author MUSI
 * @Date 2022/7/1 4:31 PM
 * @Description
 * @Version
 **/
@RestController
@RequestMapping(path = "/hm/group")
public class HmGroupController extends WebBaseController {

    //@Autowired
    private HmGroupApiService groupApiService;

    @RequestMapping(path = "/save", method = RequestMethod.POST)
    public HaobanResponse saveHmGroupSetting(@Valid HmGroupSettingVO hmGroupSettingVO){
        WebLoginDTO loginUser = AuthWebRequestUtil.getLoginUser();
        HmGroupDTO hmGroupDTO = new HmGroupDTO();
        hmGroupDTO.setGroupName(hmGroupSettingVO.getGroupName());
        hmGroupDTO.setCreatorId(loginUser.getHanbaoUserId());
        hmGroupDTO.setCreatorName(loginUser.getClerkName());
        hmGroupDTO.setEnterpriseId(loginUser.getEnterpriseId());
        hmGroupDTO.setWxEnterpriseId(loginUser.getWxEnterpriseId());
        ServiceResponse<Long> serviceResponse = groupApiService.saveOrUpdateHmGroupSetting(hmGroupDTO);
        return resultResponse(HaoBanErrCode.ERR_1, serviceResponse.getResult());
    }
}
